local Quad =  love.graphics.newQuad

function love.load()
  --Images
  hills = love.graphics.newImage("Hills.png")
  HeroSprite = love.graphics.newImage("ken1.png")
  CloudImg = love.graphics.newImage("Cloud.png")
  --Life = love.graphics.newImage("heart.png")
  
  --Sound
  --Music = love.audio.newSource("")
  --love.audio.play(Music)
  --Music:setVolume(.05)
 --[[ MainTheme = love.audio.newSource("sounds/MainTheme.wav")
  MainTheme:setVolume(.5)
  MainTheme:setLooping(true)
  MainTheme:play()]]
  
 --Particle Engine
 dust = love.graphics.newImage("dust.png")
  p = love.graphics.newParticleSystem(dust, 10)
 
  p:setEmissionRate          (6)
  p:setLifetime              (1)
  p:setParticleLife          (.30)
  p:setDirection             (10)
  p:setSpread                (2)
  p:setSpeed                 (10, 30)
  p:setGravity               (0)
  p:setRadialAcceleration    (100)
  p:setTangentialAcceleration(0)
  p:setSizes                 (1)
  p:setSizeVariation         (0.5)
  p:setRotation              (0)
  p:setSpin                  (0)
  p:setSpinVariation         (0)
  p:setColors                (200, 0, 0, 12)
  p:stop();
  
  --Playable Character
  Hero = {}
  Hero.x = 200
  Hero.y = 350
  Hero.speed = 50
  Hero.state = "ground"
  Hero.maxjump = 50
 
 --Global Constants
 science = {}
 science.gravity = 300
 science.ground = 350
  
  --Life Bar
  Hearts = {}
  for i = 1, 5 do
    Heart = {}
    Heart.height = 32
    Heart.width = 32
    Heart.x = i * (Heart.width) - 20
    Heart.y = Heart.height - 20
    table.insert(Hearts, Heart)
  end
  
  --Cloud Parameters
  Cloud = {}
  Cloud.x = 0
  Cloud.y = 50
  Cloud.speed = 5
  
  quads = {
    right = {
      Quad(216, 15, 52, 57, 700, 3600);
      Quad(281, 15, 46, 57, 700, 3600);
      Quad(338, 14, 35, 58, 700, 3600);
      Quad(382, 15, 50, 57, 700, 3600);
      Quad(441, 13, 53, 59, 700, 3600);
      Quad(511, 13, 39, 59, 700, 3600);
      Quad(567, 13, 36, 59, 700, 3600);
      Quad(616, 13, 49, 59, 700, 3600);
   };
   left = {
      Quad(641, 1144, 50, 59, 700, 3600);
      Quad(581, 1144, 44, 59, 700, 3600);
      Quad(535, 1144, 35, 59, 700, 3600);
      Quad(477, 1144, 50, 59, 700, 3600);
      Quad(414, 1144, 53, 59, 700, 3600);
      Quad(357, 1144, 39, 59, 700, 3600);
      Quad(303, 1144, 36, 59, 700, 3600);
      Quad(242, 1144, 49, 59, 700, 3600);
   };
   standing = {
     Quad(  1, 9, 40, 62, 700, 3600);
     Quad( 52, 9, 40, 62, 700, 3600);
     Quad(103, 9, 40, 62, 700, 3600);
     Quad(157, 9, 40, 62, 700, 3600);
   };
  }
  iterator = 1
  max = 0
  timer = 0
  moving = false
  direction = "standing" 
  speedmult = .1
end

function love.update(dt)
  
  if direction == "right" then
    max = 8
  end
  if direction == "standing" then
    max = 4
  end
  if direction == "left" then
    max = 8
  end
  
  --Switches between sprite frames, if moving
  if moving or moving == false then
    timer = timer + dt
    if timer > speedmult then
      timer = 0
      iterator = iterator + 1
      if iterator > max then
        iterator = 1
      end
    end
  end
  
  --Moving the character
  --[[if direction == "right" or direction == "left" then
    Hero.x = Hero.x + (delta_x*(Hero.speed * dt))
    if love.keyboard.isDown(" ") then
      p:start()
      Hero.x = Hero.x + (delta_x*((Hero.speed + 100) * dt))
      if Hero.state == "jumping" then
        p:stop();
      end
      
      p:setPosition(Hero.x, Hero.y + 10)
      speedmult = .05
    else
      p:stop()
    end
  end ]]
  p:update(dt)
  
  --Jumping
  if Hero.state == "jumping" then
    Hero.y = Hero.y + (delta_y * ((science.gravity ) * dt))
    if love.keyboard.isDown("a") == true then
      Hero.maxjump = 80
    else
      Hero.maxjump = 50
    end
    
    if Hero.y < (science.ground - Hero.maxjump) then
      delta_y = 1
      Hero.y = Hero.y + (delta_y * (science.gravity * dt))
    end
    if Hero.y >= science.ground then
      Hero.state = "ground"
      Hero.y = science.ground 
    end
  end
    
        
        
      
 
    
 
  --Prevents player from going off screen
  if Hero.x > 810 then
    Hero.x = -20
  elseif Hero.x < -30 then
    Hero.x = 810
  end
  
  
  --Move the cloud
  Cloud.x = Cloud.x + (Cloud.speed * dt)
  if Cloud.x >= 800 then
    Cloud.x = 0 - 200
  end  
end


function love.draw()
  
  --Sky
  love.graphics.setColor(12,194,255)
  love.graphics.rectangle("fill", 0, 0, 800,300)
  
 --Cloud
  love.graphics.setColor(255,255,255)
  love.graphics.draw(CloudImg, Cloud.x, Cloud.y)
  
  --[[Hearts
  love.graphics.setColor(255,255,255)
  for i, v in ipairs(Hearts) do
    love.graphics.draw(Life, v.x, v.y)
  end]]
 
 --Ground
  love.graphics.setColor(65,128,22)
  love.graphics.rectangle("fill", 0, 300, 800, 300)
    
  --Hills
  love.graphics.setColor(255,255,255)
  love.graphics.draw(hills,0,-20)
  
  --Road
  love.graphics.setColor(201, 155, 85, 255)
  love.graphics.rectangle("fill", 0, 400, 800, 50)
  
  --Dust Particle
  love.graphics.draw(p,20, 20)
  
  --Hero
  love.graphics.setColor(255,255,255)
  love.graphics.drawq(HeroSprite, quads[direction][iterator], Hero.x, Hero.y)
end

function love.keypressed(key, unicode)
  if key == "left" then
    delta_x = -1
    moving = true
    direction = "left"
  elseif key == "right" then
    delta_x = 1
    moving = true
    direction = "right"
  end  
  if key == "a" and Hero.state ~= "jumping" then
    delta_y = -1
    Hero.state = "jumping"
  end
  
end

function love.keyreleased(key)
  if love.keyboard.isDown("left") == false and love.keyboard.isDown("right") == false then
      direction = "standing"
      iterator = 1
      moving = false
  end
  if love.keyboard.isDown("left") == false and love.keyboard.isDown("right") == true then
    direction = "right"
    delta_x = 1
  elseif love.keyboard.isDown("left") == true and love.keyboard.isDown("right") == false then
    direction = "left"
    delta_x = -1
  end
  
  if key == " " then
    speedmult = .08
  end 
end


